<!DOCTYPE html>
<html lang="en">

<head>
	<title>Customer CRUD</title>
	<meta charset="utf-8">
	<meta name="viewport" content="width=device-width, initial-scale=1">
	<link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">

	<link rel="stylesheet" href="mystyle.css">
	<script src="https://cdnjs.cloudflare.com/ajax/libs/moment.js/2.24.0/moment.min.js"></script>
	<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>

	<script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
	<link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.3/css/all.min.css" />


	<!-- Import Datatable sau jquery -->
	<!-- Import them style bootstrap cho datatable -->
	<link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
	<script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
	<script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>

</head>

<body>

	<div class="container">
		<h2 style="text-align: center;">Quản trị Customer</h2>

		<!-- Create voucher modal -->
		<div>
			<div id="create-customer-modal" class="modal fade" tabindex="-1">
				<div class="modal-dialog">
					<div class="modal-content">
						<div class="modal-header">
							<h5 class="modal-title" id="h5-modal-title">Create new customer</h5>
							<button class="close" data-dismiss="modal">&times;</button>
						</div>
						<div class="modal-body">
							<form>
								<div class="row form-group">
									<div class="col-sm-3">
										<label>address</label>
									</div>
									<div class="col-sm-9">
										<input type="text" id="input-address" class="form-control">
									</div>
								</div>
								<div class="row form-group">
									<div class="col-sm-3">
										<label>city</label>
									</div>
									<div class="col-sm-9">
										<input type="text" id="input-city" class="form-control">
									</div>
								</div>
								<div class="row form-group">
									<div class="col-sm-3">
										<label>country</label>
									</div>
									<div class="col-sm-9">
										<input type="text" id="input-country" name="note" class="form-control">
									</div>
								</div>
								<div class="row form-group">
									<div class="col-sm-3">
										<label>creditLimit</label>
									</div>
									<div class="col-sm-9">
										<input type="number" id="input-credit-limit" name="note" class="form-control">
									</div>
								</div>
								<div class="row form-group">
									<div class="col-sm-3">
										<label>firstname</label>
									</div>
									<div class="col-sm-9">
										<input type="text" id="input-firstname" name="note" class="form-control">
									</div>
								</div>
								<div class="row form-group">
									<div class="col-sm-3">
										<label>lastname</label>
									</div>
									<div class="col-sm-9">
										<input type="text" id="input-lastname" name="note" class="form-control">
									</div>
								</div>
								<div class="row form-group">
									<div class="col-sm-3">
										<label>phone number</label>
									</div>
									<div class="col-sm-9">
										<input type="text" id="input-phonenumber" name="note" class="form-control">
									</div>
								</div>
								<div class="row form-group">
									<div class="col-sm-3">
										<label>postal code</label>
									</div>
									<div class="col-sm-9">
										<input type="text" id="input-postalcode" name="note" class="form-control">
									</div>
								</div>
								<div class="row form-group">
									<div class="col-sm-3">
										<label>Sale Rep Employee Number</label>
									</div>
									<div class="col-sm-9">
										<input type="number" id="input-salerepemployeenumber" name="note"
											class="form-control">
									</div>
								</div>
								<div class="row form-group">
									<div class="col-sm-3">
										<label>state</label>
									</div>
									<div class="col-sm-9">
										<input type="text" id="input-state" name="note" class="form-control">
									</div>
								</div>

							</form>
						</div>
						<div class="modal-footer">
							<button class="btn btn-secondary" id="btn-create-cancel"
								data-dismiss="modal">Cancel</button>
							<button class="btn btn-primary" id="btn-create-customer">Create Customer</button>
						</div>
					</div>
				</div>
			</div>
		</div>

		<!-- Update voucher modal -->
		<div>
			<div id="update-customer-modal" class="modal fade" tabindex="-1">
				<div class="modal-dialog">
					<div class="modal-content">
						<div class="modal-header">
							<h5 class="modal-title" id="h5-modal-title">Update Album</h5>
							<button class="close" data-dismiss="modal">&times;</button>
						</div>
						<div class="modal-body">
							<form>
								<div class="row form-group">
									<div class="col-sm-3">
										<label>address</label>
									</div>
									<div class="col-sm-9">
										<input type="text" id="input-address-update" class="form-control">
									</div>
								</div>
								<div class="row form-group">
									<div class="col-sm-3">
										<label>city</label>
									</div>
									<div class="col-sm-9">
										<input type="text" id="input-city-update" class="form-control">
									</div>
								</div>
								<div class="row form-group">
									<div class="col-sm-3">
										<label>country</label>
									</div>
									<div class="col-sm-9">
										<input type="text" id="input-country-update" name="note" class="form-control">
									</div>
								</div>
								<div class="row form-group">
									<div class="col-sm-3">
										<label>creditLimit</label>
									</div>
									<div class="col-sm-9">
										<input type="number" id="input-credit-limit-update" name="note"
											class="form-control">
									</div>
								</div>
								<div class="row form-group">
									<div class="col-sm-3">
										<label>firstname</label>
									</div>
									<div class="col-sm-9">
										<input type="text" id="input-firstname-update" name="note" class="form-control">
									</div>
								</div>
								<div class="row form-group">
									<div class="col-sm-3">
										<label>lastname</label>
									</div>
									<div class="col-sm-9">
										<input type="text" id="input-lastname-update" name="note" class="form-control">
									</div>
								</div>
								<div class="row form-group">
									<div class="col-sm-3">
										<label>phone number</label>
									</div>
									<div class="col-sm-9">
										<input type="text" id="input-phonenumber-update" name="note"
											class="form-control">
									</div>
								</div>
								<div class="row form-group">
									<div class="col-sm-3">
										<label>postal code</label>
									</div>
									<div class="col-sm-9">
										<input type="text" id="input-postalcode-update" name="note"
											class="form-control">
									</div>
								</div>
								<div class="row form-group">
									<div class="col-sm-3">
										<label>Sale Rep Employee Number</label>
									</div>
									<div class="col-sm-9">
										<input type="number" id="input-salerepemployeenumber-update" name="note"
											class="form-control">
									</div>
								</div>
								<div class="row form-group">
									<div class="col-sm-3">
										<label>state</label>
									</div>
									<div class="col-sm-9">
										<input type="text" id="input-state-update" name="note" class="form-control">
									</div>
								</div>

							</form>
						</div>
						<div class="modal-footer">
							<button class="btn btn-secondary" id="btn-create-cancel"
								data-dismiss="modal">Cancel</button>
							<button class="btn btn-primary" id="btn-update-album">Update Album</button>
						</div>
					</div>
				</div>
			</div>
		</div>

		<!-- Delete confirm modal -->
		<div>
			<div class="modal fade" tabindex="-1" id="delete-modal">
				<div class="modal-dialog">
					<div class="modal-content">
						<div class="modal-header">
							<h5 class="modal-title" id="h5-modal-title">Album Delete Confirmation</h5>
							<button class="close" data-dismiss="modal">&times;</button>
						</div>
						<div class="modal-body">
							<label>Bạn có chắc chắn muốn xóa album này không?</label>
						</div>
						<div class="modal-footer">
							<button class="btn btn-danger" id="btn-confirm-delete-customer">Confirm</button>
							<button class="btn btn-secondary" data-dismiss="modal">Cancel</button>
						</div>
					</div>
				</div>
			</div>
		</div>
		<button class="btn btn-success " id="create-customer">Add Customer</button>
		<button class="btn btn-success " id="export-to-excel">Export to excel</button>
		<table class="table table-bordered table-striped table-hover" id="customer-table">
			<thead>
				<tr>
					<th>STT</th>
					<th>address</th>
					<th>city</th>
					<th>country</th>
					<th>creditLimit</th>
					<th>firstName</th>
					<th>lastName</th>
					<th> phoneNumber</th>
					<th>postalCode</th>
					<th>salesRepEmployeeNumber</th>
					<th>state</th>
					<th>Action</th>
					<th>Detail</th>
				</tr>
		</table>
	</div>
	<script>
		/*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
		// Biến mảng hằng số chứa danh sách tên các thuộc tính
		const gCUSTOMER_COLS = ["id", "address", "city", "country", "creditLimit", "firstName", "lastName", "phoneNumber", "postalCode", "salesRepEmployeeNumber", "state", "action", "detail"];

		// Biến mảng toàn cục định nghĩa chỉ số các cột tương ứng
		const gCUSTOMER_STT_COL = 0;
		const gCUSTOMER_ADDRESS_COL = 1;
		const gCUSTOMER_CITY_COL = 2;
		const gCUSTOMER_COUNTRY_COL = 3;
		const gCUSTOMER_CREDIT_COL = 4;
		const gCUSTOMER_FIRSTNAME_COL = 5;
		const gCUSTOMER_LASTNAME_COL = 6;
		const gCUSTOMER_PHONE_COL = 7;
		const gCUSTOMER_POSTAL_COL = 8;
		const gCUSTOMER_SALEEMPLOYEENUMBER_COL = 9;
		const gCUSTOMER_STATE_COL = 10;
		const gCUSTOMER_ACTION_COL = 11;
		const gCUSTOMER_DETAIL_COL = 12;


		var table = $("#customer-table").DataTable({
			columns: [
				{ data: gCUSTOMER_COLS[gCUSTOMER_STT_COL] },
				{ data: gCUSTOMER_COLS[gCUSTOMER_ADDRESS_COL] },
				{ data: gCUSTOMER_COLS[gCUSTOMER_CITY_COL] },
				{ data: gCUSTOMER_COLS[gCUSTOMER_COUNTRY_COL] },
				{ data: gCUSTOMER_COLS[gCUSTOMER_CREDIT_COL] },
				{ data: gCUSTOMER_COLS[gCUSTOMER_FIRSTNAME_COL] },
				{ data: gCUSTOMER_COLS[gCUSTOMER_LASTNAME_COL] },
				{ data: gCUSTOMER_COLS[gCUSTOMER_PHONE_COL] },
				{ data: gCUSTOMER_COLS[gCUSTOMER_POSTAL_COL] },
				{ data: gCUSTOMER_COLS[gCUSTOMER_SALEEMPLOYEENUMBER_COL] },
				{ data: gCUSTOMER_COLS[gCUSTOMER_STATE_COL] },
				{ data: gCUSTOMER_COLS[gCUSTOMER_ACTION_COL] },
				{ data: gCUSTOMER_COLS[gCUSTOMER_DETAIL_COL] }
			],
			columnDefs: [
				{ // định nghĩa lại cột action
					targets: gCUSTOMER_ACTION_COL,
					defaultContent: `
					<i class="fas fa-edit edit-customer"></i>
					<i class="fas fa-trash-alt delete-customer"></i>
			  
			`
				},
				{ // định nghĩa lại cột action
					targets: gCUSTOMER_DETAIL_COL,
					defaultContent: `
					<Button class='btn btn-primary btn-order'>Chi tiết Order</Button>
					<Button class='btn btn-warning btn-payment'>Chi tiết Payment</Button>
			  		`
				},
			]
		})
		var gRowSelected = ''
		var glistAlbum = [];
		var gCustomerIdSelected = '';
		var gRowCustomerSelected = '';
		var glistAlbumValidateUpdate = [];
		/*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
		$(document).ready(function () {
			onPageLoading();
			//export to excel
			$('#export-to-excel').on('click', function () {

				onBtnExportToExcelClick()
			})
			//create new album
			$('#create-customer').on('click', function () {

				onBtnAddCustomerClick();
			})
			$('#btn-create-customer').on('click', function () {

				onBtnCreateCustomerOnModalClick();
			})
			//edit album
			$('#customer-table').on('click', '.edit-customer', function () {

				onBtnEditCustomerClick(this);
			})
			$('#btn-update-album').on('click', function () {
				onBtnUpdateOnModalClick()
			})

			//xóa album
			$('#customer-table').on('click', '.delete-customer', function () {

				onBtnDeleteCustomerClick(this);
			})
			$('#btn-confirm-delete-customer').on('click', function () {

				onBtnConfirmOnDeleteModalClick(this);
			})

			//click nút chi tiết order
			$('#customer-table').on('click', '.btn-order', function () {

				onBtnOrderDetailClick(this);
			})
			//click nút chi tiết payment
			$('#customer-table').on('click', '.btn-payment', function () {

				onBtnPaymentDetailClick(this);
			})





		})
		/*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
		//hàm thực hiện khi nhấn nút export to excel
		function onBtnExportToExcelClick() {
			window.open(' http://localhost:8080/export/customers/excel ');
		}
		//hàm gọi api load danh sách album từ server khi tải trang
		function onPageLoading() {
			console.log('làm toi day')
			$.ajax({
				url: "http://localhost:8080/customer/all",
				type: "GET",
				dataType: "json",
				success: function (res) {
					glistAlbum = res
					console.log('check data get all customr from server', res);
					table.clear();
					table.rows.add(res);
					table.draw();
				},
				error: function (err) {
					console.log(err.response);
				}
			})
		}
		//hàm thực hiện khi nhấn nút add new album
		function onBtnAddCustomerClick() {

			$("#create-customer-modal").modal("show");

		}
		//hàm thực hiện khi nhấn create album trên modal
		function onBtnCreateCustomerOnModalClick() {
			createNewCustomer();
			$("#create-customer-modal").modal("hide");
		}
		//hàm thực hiện khi lúc nút edit
		function onBtnEditCustomerClick(paramButton) {
			$("#update-customer-modal").modal("show");
			gCustomerIdSelected = getCustomerIdFromButton(paramButton)

			console.log('check id customer selected', gCustomerIdSelected)
			callApiToGetCustomerById(gCustomerIdSelected)
		}
		//hàm thực hiện khi nhấn nút update trên modal
		function onBtnUpdateOnModalClick() {
			updateCustomer(gCustomerIdSelected);
			$("#update-customer-modal").modal("hide");

		}
		//Hàm thực hiện khi nhấn nút delete
		function onBtnDeleteCustomerClick(paramButton) {
			$("#delete-modal").modal("show");
			gCustomerIdSelected = getCustomerIdFromButton(paramButton)

		}
		//hàm thực hiện khi nhấn nút confirm trên delete modal
		function onBtnConfirmOnDeleteModalClick() {
			deletedCustomer();
			$("#delete-modal").modal("hide");

		}
		//hàm thực hiện khi nhấn nút order detail
		function onBtnOrderDetailClick(paramButton) {

			gCustomerIdSelected = getCustomerIdFromButton(paramButton)
			console.log('check id customer selected', gCustomerIdSelected);
			window.location.href = `orderOfOneCustomer.html?id=${gCustomerIdSelected}`

			// callApiToGetCustomerById(gCustomerIdSelected)
		}
		//hàm thực hiện khi nhấn nút payment detail
		function onBtnPaymentDetailClick(paramButton) {

			gCustomerIdSelected = getCustomerIdFromButton(paramButton)
			console.log('check id customer selected', gCustomerIdSelected);
			window.location.href = `paymentOfOneCustomer.html?id=${gCustomerIdSelected}`

			// callApiToGetCustomerById(gCustomerIdSelected)
		}
		/*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
		//hàm trả ra id album khi nhấn nút edit
		function getCustomerIdFromButton(paramButton) {
			var vTableRow = $(paramButton).parents("tr");
			gRowCustomerSelected = table.row(vTableRow).data();
			console.log(gRowCustomerSelected.id);
			return gRowCustomerSelected.id;
		}
		//hàm gọi api để lấy album cần edit theo id
		function callApiToGetCustomerById(id) {

			$.ajax({
				url: `http://localhost:8080/customer/details/${id}`,
				async: false,
				type: "GET",
				dataType: "json",
				success: function (res) {
					console.log('check data customer need to update ress', res);
					if (glistAlbum && glistAlbum.length > 0) {
						glistAlbum.map((item, index) => {
							if (item.id == res.id) {
								glistAlbum.splice(index, 1)
							}
						})
					}
					showDataUpdateOnForm(res);
				},
				error: function (err) {
					console.log(err.response);
				}
			})

		}
		//hàm hiển thị data lên form edit
		function showDataUpdateOnForm(paramAlbum) {


			$('#input-address-update').val(paramAlbum.address);
			$('#input-city-update').val(paramAlbum.city);
			$('#input-country-update').val(paramAlbum.country);
			$('#input-credit-limit-update').val(paramAlbum.creditLimit);
			$('#input-firstname-update').val(paramAlbum.firstName);
			$('#input-lastname-update').val(paramAlbum.lastName);
			$('#input-phonenumber-update').val(paramAlbum.phoneNumber);
			$('#input-postalcode-update').val(paramAlbum.phoneNumber);
			$('#input-salerepemployeenumber-update').val(paramAlbum.salesRepEmployeeNumber);
			$('#input-state-update').val(paramAlbum.state);

		}

		function updateCustomer(paramAlbumId) {
			let objData = {
				address: '',
				city: '',
				country: '',
				creditLimit: 0,
				firstName: '',
				lastName: '',
				phoneNumber: '',
				postalCode: '',
				salesRepEmployeeNumber: 0,
				state: '',
			}
			let objDataFromForm = getDataOnFormUpdate(objData);
			callApiToUpdateData(paramAlbumId, objDataFromForm);
			onPageLoading();
			// var vCheck = validateDataOnform(objDataFromForm);
			// if (vCheck) {
			// 	let albumExist = '';
			// 	if (glistAlbum && glistAlbum.length > 0) {

			// 		for (let i = 0; i < glistAlbum.length; i++) {
			// 			if (glistAlbum[i].albumCode == objDataFromForm.albumCode) {
			// 				alert("Album existed");
			// 				albumExist = glistAlbum[i];
			// 				console.log('Album existed', albumExist)
			// 			}
			// 		}

			// 	}
			// 	if (albumExist == '') {

			// 		callApiToUpdateData(paramAlbumId, objDataFromForm);
			// 		onPageLoading();
			// 	}



			// }
		}




		//hàm thu thập dư liệu trên form update
		function getDataOnFormUpdate(obj) {


			obj.address = $('#input-address-update').val();
			obj.city = $('#input-city-update').val();
			obj.country = $('#input-country-update').val();
			obj.creditLimit = $('#input-credit-limit-update').val();
			obj.firstName = $('#input-firstname-update').val();
			obj.lastName = $('#input-lastname-update').val();
			obj.phoneNumber = $('#input-phonenumber-update').val();
			obj.postalCode = $('#input-postalcode-update').val();
			obj.salesRepEmployeeNumber = $('#input-salerepemployeenumber-update').val();
			obj.state = $('#input-state-update').val();
			return obj
		}
		//hàm gọi api để update album
		function callApiToUpdateData(id, paramOrderObject) {
			$.ajax({
				async: false,
				url: `http://localhost:8080/customer/update/${id}`,
				type: 'PUT',
				async: false,
				contentType: "application/json;charset=UTF-8",
				data: JSON.stringify(paramOrderObject),
				success: function (res) {
					console.log('check data update response', res);

				},
				error: function (error) {
					console.assert(error.responseText)
				}
			})
		}

		//save new album
		function createNewCustomer() {
			let objData = {
				address: '',
				city: '',
				country: '',
				creditLimit: 0,
				firstName: '',
				lastName: '',
				phoneNumber: '',
				postalCode: '',
				salesRepEmployeeNumber: 0,
				state: '',

			}
			let objDataFromForm = getDataOnForm(objData);
			callApiToPostData(objDataFromForm);
			onPageLoading();
			// var vCheck = validateDataOnform(objDataFromForm);
			// if (vCheck) {
			// 	if (glistAlbum && glistAlbum.length > 0) {
			// 		glistAlbum.map(item => {
			// 			if (item.albumCode == objDataFromForm.albumCode) {
			// 				alert("Album existed")
			// 			} else {
			// 				console.log('check data post', objDataFromForm)
			// 				callApiToPostData(objDataFromForm);
			// 				onPageLoading();

			// 			}
			// 		})
			// 	}

			// }

		}
		//hàm thực hiện validate dữ liệu trên form
		// function validateDataOnform(paramObjData) {
		// 	if (!paramObjData.albumCode) {
		// 		alert('Missing album code')
		// 		return false;
		// 	}
		// 	if (!paramObjData.albumName) {
		// 		alert('Missing album name')
		// 		return false;
		// 	}
		// 	if (!paramObjData.description) {
		// 		alert('Missing description')
		// 		return false;
		// 	}
		// 	return true;


		// }
		//hàm thu thập dư liệu trên form
		function getDataOnForm(obj) {
			obj.address = $('#input-address').val();
			obj.city = $('#input-city').val();
			obj.country = $('#input-country').val();
			obj.creditLimit = $('#input-credit-limit').val();
			obj.firstName = $('#input-firstname').val();
			obj.lastName = $('#input-lastname').val();
			obj.phoneNumber = $('#input-phonenumber').val();
			obj.postalCode = $('#input-postalcode').val();
			obj.salesRepEmployeeNumber = $('#input-salerepemployeenumber').val();
			obj.state = $('#input-state').val();
			return obj
		}
		//hàm gọi api để tạo album mới
		function callApiToPostData(paramOrderObject) {
			$.ajax({
				async: false,
				url: `http://localhost:8080/customer/create`,
				type: 'POST',
				async: false,
				contentType: "application/json;charset=UTF-8",
				data: JSON.stringify(paramOrderObject),
				success: function (res) {

					console.log('check data post response', res);

				},
				error: function (error) {
					console.assert(error.responseText)
				}
			})
		}
		function deletedCustomer() {
			callApiToDeleteData(gCustomerIdSelected);
			onPageLoading();
		}
		function callApiToDeleteData(id) {
			$.ajax({
				async: false,
				url: `http://localhost:8080/customer/delete/${id}`,
				type: 'DELETE',
				async: false,
				// contentType: "application/json;charset=UTF-8",
				// data: JSON.stringify(paramOrderObject),
				success: function (res) {
					alert('Delete success')

				},
				error: function (error) {
					console.assert(error.responseText)
				}
			})
		}




	</script>
</body>

</html>